/*  P5-1ellipsoidhelical.c  (Program 5-1)  */

/* --- vO̐ ---
@ȉ~̃f[^t@CwJXLef[^쐬vOD

́F
  1Do͂铊ef[^̃t@C
  2D2e̕@@@@@@@ixj
  3D2e̍@@@@@@izj
  4D2ef[^̓e@iƕj
  5Def[^̑Spx@@@@ ixj
  6Def[^zJnʒuZ0izj
  7Def[^z1dizj
  8D]S܂ł̒ifj
  9Dẻ]i1: , -1: Ej

óF
  ȉ~̃f[^쐬ef[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char     g_f1[50] = "n5-1.prj"; /* output file name */
int      g_px = 256;            /* number of x-width */
int      g_pz = 256;            /* number of z-width */
int      g_pa = 1024;           /* number of projection */
int      g_pd = 1440;           /* total-angle degree */
int      g_zs = -256;           /* z-start point */
int      g_zd = 128;            /* z-width of one cycle */
int      g_d  = 512;            /* source origin length */
int      g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
float   *g_prj;                 /* projection data */

// ͗pRg
char *menu[] = {
	"Make ellipsoid helical-scan projection data",
	"Output file name <float> ",
	"Number of bins (X)             ",
	"Number of bins (Z)             ",
	"Number of projections          ",
	"Number of total-angle (deg)    ",
	"Number of z-start point        ",
	"Number of z-width of one cycle ",
	"Source origin length  (pixel)  ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
	};

// vg^Cv錾
void write_data(char *, float *, int);
void ellipsoidhelical(float *, int, int, int, int, int, int, int, int, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pz );
	if(*fgets(dat, 256, stdin) != '\n')  g_pz = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pd );
	if(*fgets(dat, 256, stdin) != '\n')  g_pd = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_zs );
	if(*fgets(dat, 256, stdin) != '\n')  g_zs  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_zd );
	if(*fgets(dat, 256, stdin) != '\n')  g_zd = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
}

main()
{
	int      i;

	// vOŎgpϐ̓
	getparameter();

	// f[^̈̃𓮓IɊm
	g_prj = (float *)malloc((size_t)g_px*g_pz*g_pa*sizeof(float));

	printf(" *** Making Projections ***\n");
	// f[^̏
	for(i = 0 ; i < g_px*g_pz*g_pa ; i++)
		g_prj[i] = (float)0;

	// 3-D Sheppt@g瓊e̍쐬iȉ~17j
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	 0.0000,	 0.0000,	0.7233,	0.9644,	1.2700,	 3.0000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	-0.0184,	-0.0185,	0.7008,	0.9246,	1.2241,	-1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.2583,	 0.7534,	 0.0000,	0.1270,	0.1270,	0.1270,	-1.0000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd, -0.2583,	 0.7534,	 0.0000,	0.1270,	0.1270,	0.1270,	-1.0000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	 1.1398,	-0.1957,	0.1270,	0.3400,	0.1700,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	0.5446,	-0.8387,	 0.0000,	 0.8387,	 0.5446);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	 0.0000,	-0.7620,	0.4575,	0.6099,	0.5080,	-1.0000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.7076,	-0.1378,	-0.1905,	0.0635,	0.3175,	0.3175,	 1.0000,	 0.9903,	-0.1085,	-0.0865,	 0.1089,	0.9941,	 0.0000,	 0.0860,	-0.0094,	 0.9963);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd, -0.7076,	-0.1378,	-0.1905,	0.0635,	0.3175,	0.3175,	 1.0000,	-0.9903,	-0.1085,	-0.0865,	-0.1089,	0.9941,	 0.0000,	-0.0860,	-0.0094,	 0.9963);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd, -0.0800,	-0.6050,	 0.3810,	0.0460,	0.0230,	0.0230,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	-0.6050,	 0.3810,	0.0230,	0.0230,	0.0460,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0600,	-0.6050,	 0.3810,	0.0230,	0.0460,	0.0230,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	 0.1000,	 0.3810,	0.0460,	0.0460,	0.0460,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	-0.1000,	 0.1270,	0.2581,	0.2581,	0.2581,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.0000,	 0.3500,	 0.3810,	0.2100,	0.2500,	0.2300,	 1.5000,	 1.0000,	 0.0000,	 0.0000,	 0.0000,	1.0000,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.2200,	 0.0000,	 0.3810,	0.1100,	0.3100,	0.2540,	-1.0000,	 0.9511,	-0.3090,	 0.0000,	 0.3090,	0.9511,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd, -0.2200,	 0.0000,	 0.3810,	0.1600,	0.4100,	0.3810,	-1.0000,	-0.9511,	-0.3090,	 0.0000,	-0.3090,	0.9511,	 0.0000,	 0.0000,	 0.0000,	 1.0000);
	ellipsoidhelical(g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd,  0.5600,	-0.4000,	 0.3810,	0.0300,	0.2000,	0.2000,	 1.5000,	 0.9192,	-0.3381,	 0.2020,	 0.3452,	0.9385,	 0.0000,	 0.1896,	-0.0697,	-0.9794);

	printf(" *** Write Image data   ***\n");
	// ef[^̏o
	write_data(g_f1, g_prj, g_px*g_pz*g_pa);

	// IɊmۂ̉
	free(g_prj);
}


// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void ellipsoidhelical(float *prj, int px, int pz, int pa, int pd, int zs, int zd, int d, int rd, double x0, double y0, double z0, double a, double b, double c, double den, double v11, double v12, double v13,double v21, double v22, double v23,double v31, double v32, double v33)
// float   *prj;  ef[^
// int     px;    e̕
// int     pz;    e̍
// int     pa;    e̊px
// int     pd;    ȇSpxixj
// int     zs;    z̊Jnʒu
// int     zd;    z̕
// int     d;     X]S܂ł̋ipixelj
// int     rd;    ]i1:[counter clockwise], -1:E[clockwise]j
// double  x0;    x̕sړ
// double  y0;    y̕sړ
// double  z0;    z̕sړ
// double  a;     x̎厲̔
// double  b;     y̎厲̔
// double  c;     z̎厲̔
// double  den;   ȉ~̂̔Zx
// double  v11;   ]̍svf
// double  v12;   
// double  v13;   
// double  v21;   
// double  v22;   
// double  v23;   
// double  v31;   
// double  v32;   
// double  v33;   
{
	int     i, j, k;
	double  x, z, a0, a1, a2, b0, b1, b2, A0, A1, A2, B0, B1, B2;
	double  be, si, co, s0, aa, ad, bd, cd, sq;
	double  rate = 2.0/3.0;
	static int n = 1;

	x0 *= px/2*rate;
	y0 *= px/2*rate;
	z0 *= px/2*rate;
	a  *= px/2*rate;
	b  *= px/2*rate;
	c  *= px/2*rate;
	for(i = 0 ; i < pa ; i++) {
		fprintf(stderr, "\r -- ellipsoid helical(%02d) [%4d/%4d]", n, i, pa);
		be = PI*i*pd/180.0/pa*rd;
		si = sin(be);
		co = cos(be);
		s0 = zd/(2*PI)*be+zs; // zW
		for(j = 0 ; j < pz ; j++) {
			z  = pz/2-j+s0;           // <-- z̒l͐̍W
			for(k = 0 ; k < px ; k++) {
				x  = k-px/2;
				b0 = -d*si;
				b1 =  d*co;
				b2 =  s0;               // <-- zW
				aa = sqrt(d*d+x*x+z*z);
				a0 = (x*co-b0)/aa;
				a1 = (x*si-b1)/aa;
				a2 = (z-b2)/aa;

				// W̕sړ
				b0 -= x0;
				b1 -= y0;
				b2 -= z0;

				// xNgƍW̉]
				A0 = v11*a0+v12*a1+v13*a2;
				A1 = v21*a0+v22*a1+v23*a2;
				A2 = v31*a0+v32*a1+v33*a2;
				B0 = v11*b0+v12*b1+v13*b2;
				B1 = v21*b0+v22*b1+v23*b2;
				B2 = v31*b0+v32*b1+v33*b2;

				ad = (A0*A0)/(a*a)+(A1*A1)/(b*b)+(A2*A2)/(c*c);
				bd = (A0*B0)/(a*a)+(A1*B1)/(b*b)+(A2*B2)/(c*c);
				cd = (B0*B0)/(a*a)+(B1*B1)/(b*b)+(B2*B2)/(c*c)-1;

				if((sq = bd*bd-ad*cd) > 0.0)
				{
					prj[(i*pz+j)*px+k] += (float)(2*sqrt(sq)/ad*den);
				}
			}
		}
	}
	fprintf(stderr, "\r -- ellipsoid helical(%02d) [%4d/%4d]\n", n++, i, pa);
}
