// P7-2Radon_corn_2.cpp ivO 7-2)
// @ 2 ɂR[r[ẽvO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define PI 3.14159265358979

void read_data(char [], float *, int);
void write_data(char [], float *, int);
void write_data_short(char [], short *, int);

int main(void)
{
	char f1[50],f2[50];
	int nx,ny,nz,i,k,j,l, m, n;
	double th, fai, ganma;
	double x_p, y_p, z_p;
	float  *radon_3d, *detector;
	double min, bx, by, bz;
	float *img_line;
	float *img, *img_beam;
	float *long_sum;

	double source_xyz[3], detector_xyz[3];
	double sd,lp;

	clock_t t1,t2;
	t1=clock();

	nx=ny=nz=128;
	img=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	img_beam=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	img_line=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	detector=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));
	long_sum=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));
	radon_3d=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));

	/* o͉摜̓ǂݍ */
	printf("input file name <float>:");
	scanf("%s", f1);
	printf("output file name <float>:");
	scanf("%s", f2);

	/*摜̓ǂݍ*/
	read_data(f1, img, nx*ny*nz);

	for(i=0; i<nx*ny*nz*8; i++) detector[i]=long_sum[i]=0;
	for(i=0; i<nx*ny*nz; i++) img_beam[i]=img_line[i]=0;

	/*EƂȂf*/
	double xx,yy,zz;
	/*EƂȂWђɓz*/
	double ll[4];
	/*efʉ߂钷߂ꍇɎgpWz*/
	int zahyo[4][3], ascending_xyz[3], num_v;
	double long_xyz[3];
	/*ɕёւꍇɎgpz*/
	double ascending_l[3], x_ganma, y_ganma, x_th, y_th, *beam_x, *beam_y, *beam_z;
	int x,y,z,x_v,y_v,z_v;

	beam_x=(double *)malloc((unsigned long)nx*4*sizeof(double));
	beam_y=(double *)malloc((unsigned long)nx*4*sizeof(double));
	beam_z=(double *)malloc((unsigned long)nx*4*sizeof(double));
	
	sd=2.000*(double)nx;

	for(k=0; k<ny*2; k=k+1){
		/*epx*/
		ganma=(double)k*(360.00/(nz*2.00))*PI/180.00;
		/*̍W*/
		source_xyz[0]=(double)nx*2.000*sin(ganma);
		source_xyz[1]=-(double)nx*2.000*cos(ganma);
		source_xyz[2]=0.00;
		
		for(i=0; i<ny*2; i++){
			/* ozW */
			detector_xyz[2]=(double)(ny-i);

			for(j=0; j<nx*2; j++){

				/* ^o */
				/* t@p */
				//th=(double)(j-nx)*(30.000/256.000)*PI/180.000;
				/* o̍W */
				//detector_xyz[0]=(double)nx*2.00*cos(ganma+2.00*th-PI/2.000);
				//detector_xyz[1]=(double)nx*2.00*sin(ganma+2.00*th-PI/2.000);

				/* ʌo */
				/* t@p */
				th=atan2((double)(j-nx), 2.000*(double)sd);
				/* o̍W */
				detector_xyz[0]=-sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*sin(ganma+2.00*th);
				detector_xyz[1]=sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*cos(ganma+2.00*th);

				/* R[p */
				fai=atan2(detector_xyz[2], sqrt((detector_xyz[0]-source_xyz[0])*(detector_xyz[0]-source_xyz[0])
												+(detector_xyz[1]-source_xyz[1])*(detector_xyz[1]-source_xyz[1])));

				/* Pʈړ̊ëړʂ𓱏o */
				x_ganma=-sin(ganma);
				y_ganma=cos(ganma);
				x_th=cos(ganma)*tan(th);
				y_th=sin(ganma)*tan(th);

				x_p=x_ganma+x_th;
				y_p=y_ganma+y_th;
				z_p=sqrt(tan(th)*tan(th)+1.0000)*tan(fai);

				/* PʈړẌړ */
				lp=sqrt(x_p*x_p+y_p*y_p+z_p*z_p);

				/* X̍Wz̏ */
				for(l=0; l<(int)sd*2; l++) beam_x[l]=beam_y[l]=beam_z[l]=0.000;

				/* X̒Pʈړ̌JԂ */
				for(l=0; l<(int)sd*2; l++){

					/* X̒PʈړJԂxɍWۑ */
					beam_x[l]=bx=source_xyz[0]+(double)l*x_p;
					beam_y[l]=by=source_xyz[1]+(double)l*y_p;
					beam_z[l]=bz=source_xyz[2]+(double)l*z_p;

					/* 摜ʉ߂ꍇɉflƋ̐ς̑a߂ */
					if((-nx/2+1)<bx && bx<(nx/2-2) && (-ny/2+2)<by && by<(ny/2-1) && (-nz/2+2)<bz && bz<(nz/2-1) ){

						/* e̐l */
						x=floor(beam_x[l]);
						y=floor(beam_y[l]);
						z=floor(beam_z[l]);

						/* PʈړO̐lr邱Ƃŕfʉ߂邩肷 */
						x_v=floor(beam_x[l])-floor(beam_x[l-1]);
						z_v=floor(beam_z[l])-floor(beam_z[l-1]);
						y_v=floor(beam_y[l])-floor(beam_y[l-1]);

						/*
						̕ŕfʉ߂邩߂
						̂ƂC̈Zsۂfloor֐ɂ鏭_ȉ̒l
						lȂiFx_v=-0.0000000jꍇɂ萶
						G[h߁Cif̏uabs(x_v)!=0vł͂Ȃ
						uabs(x_v)>0.001vƂ
						*/
						if(abs(x_v)>0.001) num_v=1;
						else num_v=0;

						if(abs(y_v)>0.001) num_v+=1;

						if(abs(z_v)>0.001) num_v+=1;

						/* P̉fʉ߂ꍇ */
						if(num_v==0){
							ll[0]=1.000000;
							zahyo[0][0]=beam_x[l];
							zahyo[0][1]=beam_y[l];
							zahyo[0][2]=beam_z[l];

							for(m=1; m<4; m++){
								ll[m]=0.0000;
							}

							for(m=1; m<4; m++){
								for(n=0; n<3; n++){
									zahyo[m][n]=0.00000;
								}
							}
						}
						/* ̉fʉ߂ꍇ */
						else{
					
							/* el̏ */
							for(m=0; m<3; m++){
								ascending_l[m]=ascending_xyz[m]=long_xyz[m]=0.00;
							}
							for(m=0; m<4; m++){
								for(n=0; n<3; n++){
									zahyo[m][n]=0.00;
								}
							}
							for(m=0; m<4; m++) ll[m]=0.00;

							/* EƂȂW */
							if(x_p*beam_x[l]>=0) xx=(int)(beam_x[l]);
							else xx=(int)(beam_x[l-1]);	
							if(y_p*beam_y[l]>=0) yy=(int)(beam_y[l]);
							else yy=(int)(beam_y[l-1]);
							if(z_p*beam_z[l]>=0) zz=(int)(beam_z[l]);
							else zz=(int)(beam_z[l-1]);

							/* E܂ł̒Ɗe̒Pʈړ̈ړʂ̊ */
							long_xyz[0]=((double)xx-beam_x[l-1])/x_p;
							long_xyz[1]=((double)yy-beam_y[l-1])/y_p;
							long_xyz[2]=((double)zz-beam_z[l-1])/z_p;

							/* f̋E𒴂Ȃ̋0ɂ */
							if(abs(x_v)<0.001) long_xyz[0]=0;
							if(abs(y_v)<0.001) long_xyz[1]=0;
							if(abs(z_v)<0.001) long_xyz[2]=0;
							
							/* 
							ɕёւ
							ascending_xyz:ɕёւ x,y,z ̏Ԃۑ
							ascending_l:ɕёւ̋ۑ
							*/
							for(m=0; m<3; m++){
								
								/* ߂ɍŏlE܂ł̋Ƃđ݂Ȃ10.00ɂ */
								min=10.00;
								ascending_xyz[m]=10;

								/* ŏl̓o */
								for(n=0; n<3; n++){
									if(min>long_xyz[n]){
										min=long_xyz[n];
										ascending_xyz[m]=n;
									}
								}
								
								/* ŏl̒lzԍ m ɕۑ */
								n=ascending_xyz[m];
								ascending_l[m]=long_xyz[n];
								
								/* ŏlƂĕۑl͎̏ŕۑȂ߂ɏ㏑ */
								long_xyz[n]=10.00;
							}

							/* 
							eƉflQƂW̐ݒ
							zahyo[(l1`l4܂ł̋ԍ)-1][e̍W@x:0 y:1 z:2]FflQƂW
							ll[(l1`l4܂ł̋ԍ)-1]Fefʉ߂鋗
							
							l1 ͏ɕѕςz̒ 0 ȏ̒l̂ŏ̋ł
							āCzԍ͐}. 27 ̊DFfƂȂ邽߁C3-num_v ƂȂ
							*/
							ll[0]=ascending_l[3-num_v];
							zahyo[0][0]=floor(beam_x[l-1]);
							zahyo[0][1]=floor(beam_y[l-1]);
							zahyo[0][2]=floor(beam_z[l-1]);

							/* ɕѕςCɂĊe𓱏o */
							for(m=1; m<num_v; m++){
								/* 
								ɕёւꂽpēo邽ߔzԍ
								3-num_v ȏp邽߁C3-num_v+m Ƃ
								*/
								ll[m]=ascending_l[3-num_v+m]-ascending_l[(3-num_v+m)-1];

								/* W̓o͋E𒴂ɂďꍇs */
								if(ascending_xyz[3-num_v+m]==0){
									zahyo[m][0]=floor(beam_x[l]);
									zahyo[m][1]=floor(beam_y[l-1]);
									zahyo[m][2]=floor(beam_z[l-1]);
								}
								else if(ascending_xyz[3-num_v+m]==1){
									zahyo[m][0]=floor(beam_x[l-1]);
									zahyo[m][1]=floor(beam_y[l]);
									zahyo[m][2]=floor(beam_z[l-1]);
								}
								else if(ascending_xyz[3-num_v+m]==2){
									zahyo[m][0]=floor(beam_x[l-1]);
									zahyo[m][1]=floor(beam_y[l-1]);
									zahyo[m][2]=floor(beam_z[l]);
								}
							}

							/* PʈړX݂W̋ 1 珸ɕѕς̍őllƂȂ */
							ll[num_v]=1.0000-ascending_l[2];
							zahyo[num_v][0]=floor(beam_x[l]);
							zahyo[num_v][1]=floor(beam_y[l]);
							zahyo[num_v][2]=floor(beam_z[l]);

						}
						/*eflƋ̐ς̑a𓱏o*/
						for(m=0; m<=num_v; m++){
							x=zahyo[m][0]+nx/2;
							y=ny/2-zahyo[m][1];
							z=nz/2-zahyo[m][2];

							detector[k*nx*ny*4+i*nx*2+j]+=lp*ll[m]*img[z*nx*ny+y*nx+x];
						}
					}
				}
			}
		}
		printf("%d\r", /*(int)((double)(k)/((double)nz*2.00*4.00)*100.0)*/k);
	}

	/* 쐬hϊ̏o */
	write_data(f2, detector, nx*ny*nz*8);

	t2=clock();
	printf("vԁF%f\n",(double)(t2-t1)/CLOCKS_PER_SEC);


	free(img);
	free(img_line);
	free(radon_3d);
	free(detector);
	free(long_sum);
	free(img_beam);

	free(beam_x);
	free(beam_y);
	free(beam_z);

}
void read_data(char fi[], float *img, int size)
{	
	FILE *fp;
	if((fp=fopen(fi,"rb"))==NULL){
		printf("error input data");
		exit(1);
	}
	fread(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data(char fi[], float *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data_short(char fi[], short *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(short),size,fp);
	fclose(fp);
}
