// P7-5FBP_corn.cppivO 7-5)
// R[r[ẽtB^␳tevO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define PI 3.14159265358979

void read_data(char [], float *, int);
void write_data(char [], float *, int);
void write_data_short(char [], short *, int);

void point_back_projection(float *detector, float *long_sum, int zd, int yd, int xd, double *img, double source_xyz[], double detector_xyz[], int nx, int ny, int nz, double sd)
{
	int j, m;
	int in_out;
	double x_p, y_p, z_p;
	int xyz;
	double sub_x, sub_y, sub_z, sub[3], min, bx, by, bz, floor_x, floor_y, floor_z;

	/* PʂɐiލW */
	x_p=(double)(detector_xyz[0]-source_xyz[0])/(2.0000*sd);
	y_p=(double)(detector_xyz[1]-source_xyz[1])/(2.0000*sd);
	z_p=(double)(detector_xyz[2]-source_xyz[2])/(2.0000*sd);

	in_out=0;

	/* X̒Pʈړ̌JԂ */
	for(j=0; j<sd*2; j++){

		/* 摜ʉ߂Ȃꍇ */
		if(in_out==0){

			/* XPʈړJԂ */
			by=source_xyz[1]+y_p*(double)j;
			bx=source_xyz[0]+(double)j*x_p;
			bz=source_xyz[2]+(double)j*z_p;

			/* 
			xyz:摜ʉ߂ꍇɑỎf̒ʉ߂łǂ̋̕EɒBϐix:0 y:1 z:2j
			摜ʉ߂Ȃꍇ -1 Ƃ
			*/
			xyz=-1;

		}
		/* 摜ʉ߂ꍇɉfʉ߂ƌo̒l̐ς̑a߂ */
		if((-nx/2+1)<bx && bx<(nx/2-2) && (-ny/2+2)<by && by<(ny/2-1) && (-nz/2+2)<bz && bz<(nz/2-1) ){
			
			/* e̐l */
			floor_x=floor(bx);
			floor_y=floor(by);
			floor_z=floor(bz);
				
			/*
			O̍W̍XV x,y,z ̂ꂼǂ̒lɂɂC
			ɂȂl͐ł邽ߕ␳
			*/
			if(fabs(bx-floor_x)<0.000001 || fabs(bx-floor_x)>0.999999){
				if(x_p>=0) floor_x+=1.00;
				else floor_x+=-1.00;
			}
			if(fabs(by-floor_y)<0.000001 || fabs(by-floor_y)>0.999999){
				if(y_p>=0) floor_y+=1.00;
				else floor_y+=-1.00;
			}
			if(fabs(bz-floor_z)<0.000001 || fabs(bz-floor_z)>0.999999){
				if(z_p>=0) floor_z+=1.00;
				else floor_z+=-1.00;
			}

			/* fʉ߂܂ł x,y,z łǂقǋ邩߂ */
			if(x_p>=0) sub_x=floor_x+1.0000000-bx;
			else if(x_p<0) sub_x=floor_x-bx;

			if(y_p>=0) sub_y=floor_y+1.0000000-by;
			else if(y_p<0) sub_y=floor_y-by;

			if(z_p>=0) sub_z=floor_z+1.0000000-bz;
			else if(z_p<0) sub_z=floor_z-bz;

			/* x,y,z ̋PʃxNgŏZ邱Ƃŋ߂ */
			sub[0]=sub_x/x_p;
			sub[1]=sub_y/y_p;
			sub[2]=sub_z/z_p;

			/* O񋫊EɒB͎̋E܂ŋ 1.000 邽 */
			if(xyz==0) sub[0]=fabs(1.00000/x_p);
			else if(xyz==1) sub[1]=fabs(1.00000/y_p);
			else if(xyz==2) sub[2]=fabs(1.00000/z_p);

			/* ̍ŏl𓱏o */
			min=sub[0];
			xyz=0;
			for(m=1; m<3; m++){
			if(min>sub[m]){
					min=sub[m];
					xyz=m;
				}
			}

			/* ˓_ʉߓ_̋Ɖfl̐ς𓱏o */
			if(long_sum[zd*nx*ny*4+yd*nx*2+xd]!=0){
				/* efʉ߂ l_sum1 ̒lŏZlƌo̒l̐ς̑a */
				img[(nz/2-(int)((floor)(bz)))*nx*ny+(ny/2-(int)((floor)(by)))*nx+(int)((floor)(bx))+nx/2]+=detector[zd*nx*ny*4+yd*nx*2+xd]*min/long_sum[zd*nx*ny*4+yd*nx*2+xd];
			}
			else img[(nz/2-(int)((floor)(bz)))*nx*ny+(ny/2-(int)((floor)(by)))*nx+(int)((floor)(bx))+nx/2]+=0.00000;

			/*̉fɐiނ߁Cʉߓ_˓_ɍXV*/
			bx+=sub[xyz]*x_p;
			by+=sub[xyz]*y_p;
			bz+=sub[xyz]*z_p;

			/*t@g摜ːiނ߁Cin_out=10 Ƃ*/
			in_out=10;
		}
	}

}

void FFT(float *fr, float *fi, int nx, int ir)
{
	int *ibr,l,n2,r,pair,m,n,i,j,a;
	float buff, *fr2, *fi2;
	double w1, w2, co, si;

	if(ir==-1){
		a=nx;
	}
	else a=1;

	ibr=(int *)malloc((unsigned long)nx*sizeof(int));       //ʑ]q
	fr2=(float *)malloc((unsigned long)nx*sizeof(float));
	fi2=(float *)malloc((unsigned long)nx*sizeof(float));	

	for(i=0; i<nx; i++) fr2[i]=fi2[i]=0;

	/*FFT<Cooley-Tukey>*/
	for(i=0; i<nx/2; i++){
		buff=fr[i];
		fr[i]=fr[i+nx/2];
		fr[i+nx/2]=buff;
	}

	r=(int)(log((double) nx)/log((double) 2));  //rF̓f[^2̉悩

	for(l=1; l<=r; l++){
		pair=(int)(pow(2.0, (double)(l-1)));   //pairFdual pair̐
		n2=nx/(int)(pow(2.0, (double)l));

		/*ʑ]qׂ̂߂[xyFdouble pow(double x, double y)]*/
		for(i=0; i<nx; i++) ibr[i]=0;
		for(i=0; i<l; i++ ){
			m=nx/(int)(pow(2.0, (double)l))*(int)(pow(2.0, (double)i));
			n=m*2;
			for(j=m; j<n; j++){
				ibr[j]=ibr[j-m]+nx/(int)(pow(2.0, (double) i+1));
			}
		}

		/*FFT*/
		for(i=0; i<pair; i++){
			for(j=n2*i*2; j<n2*i*2+n2; j++){
				co=cos(2*PI*ibr[j]/nx);
				si=ir*sin(2*PI*ibr[j]/nx);
				w1=co*fr[j+n2]+si*fi[j+n2];
				w2=-si*fr[j+n2]+co*fi[j+n2];
				fr[j+n2]=(float)(fr[j]-w1);
				fi[j+n2]=(float)(fi[j]-w2);
				fr[j]=(float)(fr[j]+w1);
				fi[j]=(float)(fi[j]+w2);
			}
		}
	}

	for(i=0; i<nx; i++){
		fr[i]/=a;
		fi[i]/=a;
	}

	/*ёւ*/
	for(i=0; i<nx; i++){
		for(j=0; j<nx; j++){
			if(i==ibr[j]) fr2[i]=fr[j];
		}
	}

	for(i=0; i<nx; i++){
		for(j=0; j<nx; j++){
			if(i==ibr[j]) fi2[i]=fi[j];
		}
	}


	for(i=0; i<nx/2; i++){
		buff=fr2[i];
		fr2[i]=fr2[i+nx/2];
		fr2[i+nx/2]=buff;

		buff=fi2[i];
		fi2[i]=fi2[i+nx/2];
		fi2[i+nx/2]=buff;
	}
	for(i=1; i<nx/2; i=i+2){
		buff=fr2[i];
		fr2[i]=fr2[nx-i];
		fr2[nx-i]=buff;
	}

	for(i=1; i<nx/2; i=i+2){
		buff=-1*fi2[i];
		fi2[i]=-1*fi2[nx-i];
		fi2[nx-i]=buff;
	}


	for(i=0; i<nx; i++){
		fr[i]=fr2[i];
		fi[i]=fi2[i];
	}

	free(fr2);
	free(fi2);
	free(ibr);
}

void FFT_2D(float *fr, float *fi, int nx, int ny, int ir)
{
	int i,j;
	float *fr2, *fi2;

	fr2=(float *)malloc((unsigned long)nx*sizeof(float));
	fi2=(float *)malloc((unsigned long)nx*sizeof(float));

	for(i=0; i<nx; i++) fr2[i]=fi2[i]=0;
	for(i=0; i<ny; i++){
		for(j=0; j<nx; j++){
			fr2[j]=fr[i*nx+j];
			fi2[j]=fi[i*nx+j];
		}
		FFT(fr2, fi2, nx, ir);
		for(j=0; j<nx; j++){
			fr[i*nx+j]=fr2[j];
			fi[i*nx+j]=fi2[j];
		}
	}

	for(i=0; i<nx; i++) fr2[i]=fi2[i]=0;
	for(j=0; j<nx; j++){
		for(i=0; i<ny; i++){
			fr2[i]=fr[i*nx+j];
			fi2[i]=fi[i*nx+j];
		}
		FFT(fr2, fi2, ny, ir);
		for(i=0; i<ny; i++){
			fr[i*nx+j]=fr2[i];
			fi[i*nx+j]=fi2[i];
		}
	}

	free(fr2);
	free(fi2);
}

int main(void)
{
	char f1[50],f2[50];
	int nx,ny,nz,i,k,j;
	float  *detector;
	double *img, ganma, th;
	float *fil, *img_beam;
	double source_xyz[3], detector_xyz[3];
	double sd,a;
	float *cij, *dete_re, *dete_im, *long_sum;
	double x,y;

	clock_t t1,t2;
	t1=clock();

	nx=ny=nz=128;
	img=(double *)malloc((unsigned long)nx*ny*nz*sizeof(double));
	img_beam=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	detector=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));
	long_sum=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));
	dete_re=(float *)malloc((unsigned long)nx*ny*4*sizeof(float));
	dete_im=(float *)malloc((unsigned long)nx*ny*4*sizeof(float));
	fil=(float *)malloc((unsigned long)nx*ny*4*sizeof(float));
	cij=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));

	/* o͉摜̓ǂݍ */
	printf("input file name <float>:");
	scanf("%s", f1);
	printf("output file name <float>:");
	scanf("%s", f2);

	/*hϊ摜̓ǂݍ*/
	read_data(f1, detector, nx*ny*nz*8);

	/* RamptB^̍쐬 */
	for(i=0; i<ny*2; i++){
		y=(ny-i);
		for(j=0; j<nx*2; j++){
			x=(j-nx);
			a=sqrt(x*x+y*y);
			if(a<(double)(nx)) fil[i*nx*2+j]=1.0+(float)(a)*10;
			else fil[i*nx*2+j]=0;
		}
	}
	/* tB^ */
	for(k=0; k<nz*2; k++){
		for(i=0; i<nx*ny*4; i++){
			dete_re[i]=detector[k*nx*ny*4+i];
			dete_im[i]=0.000;
		}

		FFT_2D(dete_re, dete_im, nx*2, ny*2, 1);

		for(i=0; i<ny*2; i++){
			for(j=0; j<nx*2; j++){
				dete_re[i*nx*2+j]*=fil[i*nx*2+j];
				dete_im[i*nx*2+j]*=fil[i*nx*2+j];
			}
		}

		FFT_2D(dete_re, dete_im, nx*2, ny*2, -1);
		
		for(i=0; i<nx*ny*4; i++){
			detector[k*nx*ny*4+i]=dete_re[i];
			dete_im[i]=0.000;
		}
		printf("%d\r", /*(int)((double)(k)/((double)nz*2.00*4.00)*100.0)*/k);
	}

	/* tB^ȅo */
	write_data("Radon_FLT_dounatsu.img", detector, nx*ny*nz*8);

	/* o̊efƂXʉ߂ l_sum1 ̓ǂݍ */
	read_data("long_sum_detector.img", long_sum, nx*ny*nz*8);
	/* 摜̊efƂXʉ߂ l_sum2 ̓ǂݍ */
	read_data("long_sum_voxel.img", cij, nx*ny*nz);

	/*  */
	for(i=0; i<nx*ny*nz; i++) img_beam[i]=img[i]=0.000;

	/* Xǁ]]Sԋ */
	sd=2.000*(double)nx;

	/* 
	^ǒȍꍇC̉f
	̊ŕωpx̐ݒ
	*/
	//th_p=360.00/(2.00*sd*PI);

	for(k=0; k<ny*2; k++){
		ganma=(double)k*(360.00/(nz*2.00))*PI/180.00;
		/*̍W*/
		source_xyz[0]=(double)nx*2.000*sin(ganma);
		source_xyz[1]=-(double)nx*2.000*cos(ganma);
		source_xyz[2]=0.00;
		
		for(i=0; i<ny*2; i++){
			/* ozW */
			detector_xyz[2]=(double)(ny-i);

			for(j=0; j<nx*2; j++){

				/* ^o */
				//th=atan2((double)(j-nx), 2.000*(double)sd);
				/*o̍W*/
				//detector_xyz[0]=-sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*sin(ganma+2.00*th+(j-nx)*th_p);
				//detector_xyz[1]=sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*cos(ganma+2.00*th+(j-nx)*th_p);

				/* ʌo */
				/* t@p */
				th=atan2((double)(j-nx), 2.000*(double)sd);

				/* o̍W */
				detector_xyz[0]=-sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*sin(ganma+2.00*th);
				detector_xyz[1]=sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*cos(ganma+2.00*th);

				/*
				vZɂ蓾W{ł 0 lɁC-0.000000 Ȃǂ
				l邱Ƃɂ蓊eȂꍇD
				̃G[h߂Ɉȉ̐Βl 0.000001 ȉ̏ꍇ͐l 0 ƂD
				*/
				if(fabs(source_xyz[0])<0.000001) source_xyz[0]=0.0000000;
				if(fabs(source_xyz[1])<0.000001) source_xyz[1]=0.0000000;
				if(fabs(source_xyz[2])<0.000001) source_xyz[2]=0.0000000;
				if(fabs(detector_xyz[0])<0.000001) detector_xyz[0]=0.0000000;
				if(fabs(detector_xyz[1])<0.000001) detector_xyz[1]=0.0000000;
				if(fabs(detector_xyz[2])<0.000001) detector_xyz[2]=0.0000000;

				point_back_projection(detector, long_sum, k, i, j, img, source_xyz, detector_xyz, nx, ny, nz, sd);

			}
		}
		printf("%d\r", k);
	}

	/* 摜̊efʉ߂鋗̑apċKi */
	for(i=0; i<nx*ny*nz; i++){
		if(cij[i]!=0) img[i]/=(double)cij[i];
	}

	for(i=0; i<nx*ny*nz; i++) img_beam[i]=(float)img[i];

	/* č\摜̏o */
	write_data(f2, img_beam, nx*ny*nz);

	t2=clock();
	printf("vԁF%f\n",(double)(t2-t1)/CLOCKS_PER_SEC);

	free(img);
	free(detector);
	free(dete_re);
	free(dete_im);
	free(fil);
	free(cij);
	free(img_beam);
}
void read_data(char fi[], float *img, int size)
{	
	FILE *fp;
	if((fp=fopen(fi,"rb"))==NULL){
		printf("error input data");
		exit(1);
	}
	fread(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data(char fi[], float *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data_short(char fi[], short *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(short),size,fp);
	fclose(fp);
}
