// P7-6Ellipsoide.cppivO 7-6)
// ȉ~̂쐬vO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define PI 3.14159265358979
void rotate_3d(float *, int, int, int, double, int, double, double, double);
void rotate(float *, int, int, double, double, double);
void write_data(char [], float *, int);
int main(void)
{
	char f1[20];
	int nx,ny,nz,i,j,k;
	double l_x, l_y, l_z, x, y, z,xx, yy, zz, th_x, th_y, th_z;
	float *img, num;

	nx=ny=nz=128;
	img=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));

	printf("output data:");
	scanf("%s",f1);
	printf("x̒:");
	scanf("%lf", &l_x);
	printf("y̒:");
	scanf("%lf", &l_y);
	printf("z̒:");
	scanf("%lf", &l_z);
	printf("Sx:");
	scanf("%lf", &xx);
	printf("Sy:");
	scanf("%lf", &yy);
	printf("Sz:");
	scanf("%lf", &zz);
	printf("px(x):");
	scanf("%lf", &th_x);
	printf("px(y):");
	scanf("%lf", &th_y);
	printf("px(z):");
	scanf("%lf", &th_z);
	printf("̉fl:");
	scanf("%f", &num);

	for(i=0; i<nx*ny*nz; i++) img[i]=0;

	l_x*=l_x;
	l_y*=l_y;
	l_z*=l_z;

	for(k=0; k<nz; k++){
		 z=(1.0-(2/(double)nz)*(double)k);
		 z=(z-zz)*(z-zz);
		 //printf("%f\n", z);
		 for(i=0; i<ny; i++){
			  y=(1.0-(2/(double)ny)*(double)i);
			  y=(y-yy)*(y-yy);
			  for(j=0; j<nx; j++){
					x=(-1.0+(2/(double)ny)*(double)j);
					x=(x-xx)*(x-xx);
					if((x/(l_x)+y/(l_y)+z/(l_z))<=1.0){
						 img[k*nx*ny+i*nx+j]=num;
						 //printf("%d\t%d\t%d\n",k,i,j);
					}
			  }
		 }
	}

	if(th_x==th_y==th_z==0) write_data(f1, img, nx*ny*nz);
	else{
		 rotate_3d(img, nx, ny, nz, -1.0*th_x, 1, xx, yy, zz);
		 rotate_3d(img, nx, ny, nz, -1.0*th_y, 2, xx, yy, zz);
		 rotate_3d(img, nx, ny, nz, -1.0*th_z, 3, xx, yy, zz);
		 write_data(f1, img, nx*ny*nz);
	}

	free(img);

}


void rotate(float *img, int nx, int ny, double th, double xx, double yy)
{
	int i,j,i0,j0,i1,j1;
	double x0,y0,si,co,x,y;
	float *ima;

	ima=(float *)malloc((unsigned long)nx*ny*sizeof(float));

	co=cos(th*PI/180); si=sin(th*PI/180);

	for(i=0; i<nx*ny; i++){
		ima[i]=0;
	}

	xx=(int)(xx*nx/2);
	yy=(int)(yy*ny/2);
	//printf("%f\t%f\n", xx, yy);

	for(i=0; i<ny; i++){
		 y=ny/2-i;
		for(j=0; j<nx; j++){
			 x=j-nx/2;
			x0=(x-xx)*co-(y-yy)*si+nx/2+xx;
			j0=(int)x0;
			j1=j0+1;
			y0=-(x-xx)*si-(y-yy)*co+ny/2-yy;
			i0=(int)y0;
			i1=i0+1;

			if(i0>=0 && i1<ny && j0>=0 && j1<nx){
				ima[i*nx+j]=(float)((j1-x0)*(i1-y0)*img[i0*nx+j0]
				            +(x0-j0)*(i1-y0)*img[i0*nx+j1]
							+(j1-x0)*(y0-i0)*img[i1*nx+j0]
							+(x0-j0)*(y0-i0)*img[i1*nx+j1]);
			}
			else{ 
				ima[i*nx+j]=0;
			}
		}
	}

	for(i=0; i<nx*ny; i++){
		img[i]=ima[i];
	}

	free(ima);
}

void rotate_3d(float *img, int nx, int ny, int nz, double th, int axis, double xx, double yy, double zz)
{
	int k,i,j;
	float *img2;

	img2=(float *)malloc((unsigned long)nx*ny*sizeof(float));

	if(axis==1){
		printf("ɉ]܂\n");
		for(j=0; j<nx; j++){
			for(k=0; k<nz; k++){
				for(i=0; i<ny; i++){
					img2[k*nx+i]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th, yy, zz);
			for(k=0; k<nz; k++){
				for(i=0; i<ny; i++){
					img[k*nx*ny+i*nx+j]=img2[k*nx+i];
				}
			}
		}
	}
	else if(axis==2){
		printf("ɉ]܂\n");
		for(i=0; i<ny; i++){
			for(k=0; k<nz; k++){
				for(j=0; j<nx; j++){
					img2[k*nx+j]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th, xx, zz);
			for(k=0; k<nz; k++){
				for(j=0; j<nx; j++){
					img[k*nx*ny+i*nx+j]=img2[k*nx+j];
				}
			}
		}
	}
	else if(axis==3){
		//printf("ɉ]܂\n");
		for(k=0; k<nz; k++){
			for(i=0; i<ny; i++){
				for(j=0; j<nx; j++){
					img2[i*nx+j]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th, xx, yy);
			for(i=0; i<ny; i++){
				for(j=0; j<nx; j++){
					img[k*nx*ny+i*nx+j]=img2[i*nx+j];
				}
			}
		}
	}
	else printf("̑IɎs܂\n");

	free(img2);

}


void write_data(char fi[],float *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(float),size,fp);
	fclose(fp);
}