/*  P2-1mkprj_fan1.c  (Program 2-1)  */

/* --- vO̐ ---
@Shepp-Logant@g̑ȉ~f[^Ɍo킪zuꂽt@r[ef[^쐬vOD

́F
  1Do͂铊ef[^̃t@C
  2Def[^̓a̐io̐j
  3Def[^̊px̐iej
  4D]S܂ł̒ifj
  5Dẻ]i1: , -1: Ej

óF
  ȉ~f[^쐬t@r[ef[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n2-1.prj";  /* output projection file name */
int     g_px = 256;             /* number of bins */
int     g_pa = 256;             /* number of projections */
int     g_d  = 512;             /* source origin length */
int     g_rd = 1;               /* rotate direction (1: counter clockwise, -1: clockwise) */
float   *g_prj;                 /* projection data */

// ͗pRg
char *menu[] = {
	"P2-1 Make Fan-beam Projection data for circular detector",
	"Output projection file name <float> ",
	"Number of bins               ",
	"Number of projections        ",
	"Source origin length (pixel) ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
};

// vg^Cv錾
void write_data(char *, float *, int);
void mkprj_fan1(float *, int, int, int, int, double, double, double, double, double, double); 

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
}

void main(void)
{
	int      i;

	// vOŎgpϐ̓
	getparameter();

	// ef[^̈̃𓮓IɊm
	g_prj = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));

	printf(" *** Making Projection ***\n");
	// ef[^̏
	for(i = 0 ; i < g_px*g_pa ; i++)
		g_prj[i] = 0;

	// Sheppt@g̍쐬
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.0,    0.69,   0.92,   0.0,  3.0 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.0184, 0.6624, 0.874,  0.0, -1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.22,  0.0,    0.11,   0.31, -18.0, -1.05);
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd, -0.22,  0.0,    0.16,   0.41,  18.0, -1.05);
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.35,   0.21,   0.25,   0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.1,    0.046,  0.046,  0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.1,    0.046,  0.046,  0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd, -0.08, -0.605,  0.046,  0.023,  0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.605,  0.023,  0.023,  0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.06, -0.605,  0.023,  0.046,  0.0,  1.5 );
    mkprj_fan1(g_prj, g_px, g_pa, g_d, g_rd,  0.56, -0.4,    0.03,   0.2,  -21.0,  1.5 );

	printf(" *** Write Image data   ***\n");
	// ef[^̏o
	write_data(g_f1, g_prj, g_px*g_pa);

	// IɊmۂ̉
	free(g_prj);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void mkprj_fan1(float *prj, int px, int pa, int d, int rd, double x0, double y0, double a, double b, double phi, double den) 
// Ɍo킪ׂꂽt@r[̓ef[^ȉ~f[^쐬
// float   *prj; 쐬铊ef[^
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// int     d;    X]S܂ł̋ipixelj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
// double  x0;   ȉ~̒SxWï̗[}1.0ɋKiĂj
// double  y0;   ȉ~̒SyWij
// double  a;    ȉ~x̌aij
// double  b;    ȉ~y̌aij
// double  phi;  ȉ~̌Xixj
// double  den;  ȉ~̔Zx
{
	int     i, j;
	double  x1, y1, ph, a2, b2, co, si, alpha, beta, ganma, sq;
	double  af, bf, sp, tp, da;

	// t@p̃TvOԊǔvZ
	da = atan2((double)px/2, (double)d)/(px/2);

	x0 *= px/2; // pixelɕϊi}1.0  }px/2j
	y0 *= px/2; // pixelɕϊ
	a  *= px/2; // pixelɕϊ
	b  *= px/2; // pixelɕϊ
	ph = PI*phi/180; // x烉WA֕ϊ
	x1 =  x0*cos(ph)+y0*sin(ph);
	y1 = -x0*sin(ph)+y0*cos(ph);
	a2 = a*a;
	b2 = b*b;
	for(i = 0 ; i < pa ; i++)
	{
		bf = 2*PI*i/pa*rd;        // t@r[̊pxij
		for(j = 0 ; j < px ; j++)
		{
			af = (j-px/2)*da;  // t@r[̌öʒuij
			sp = d*sin(af);    // pr[̓aʒuɊZir=Dsinj
			tp = af+bf;        // pxpr[ɊZi=+j
			tp -= ph;
			co = cos(tp);
			si = sin(tp);
			alpha = a2*co*co+b2*si*si;
			beta  = (a2-b2)*co*si*sp+b2*si*x1-a2*co*y1;
			ganma = b2*(sp*co-x1)*(sp*co-x1)+a2*(sp*si-y1)*(sp*si-y1)-a2*b2;
			sq = beta*beta-alpha*ganma;
		 	if(sq > 0.0)
			{
				prj[i*px+j] += (float)(2*den*sqrt(sq)/alpha);
			}
		}
	}
}
