/*  P2-4fanpara2.c  (Program 2-4)  */

/* --- vO̐ ---
@Ɍo킪zuꂽt@r[ef[^pef[^ɕϊ
vODit@pϊj

́F
  1Dt@r[ef[^̃t@C
  2Do͂pr[ef[^̃t@C
  3Def[^̓a̐io̐j
  4Def[^̊px̐iej
  5D]S܂ł̒ifj
  6Dẻ]i1: , -1: Ej

óF
  t@r[ef[^t@pϊpef[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n2-2.prj"; /* input file name */
char    g_f2[50] = "n2-4.prj"; /* output file name */
int     g_px = 256;            /* number of matrix (x) */
int     g_pa = 256;            /* number of matrix (y) */
int     g_d  = 512;            /* source origin length (pixel) */
int     g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
float   *g_fan;                /* fan data */
float   *g_par;                /* parallel data */

// ͗pRg
char *menu[] = {
	"P2-4 FAN-PARA Transform for linear detector",
	"Input  file name <float> ",
	"Output file name <float> ",
	"Number of bins                ",
	"Number of projections         ",
	"Source origin length  (pixel) ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void fanpara2(float *, float *, int, int, double, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
}

void main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// ef[^̈̃𓮓IɊm
	g_fan = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));
	g_par = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// t@r[ef[^̓ǂݏo
	read_data(g_f1, g_fan, g_px*g_pa);

	printf(" *** FAN-PARA Transform ***\n");
	// t@pϊ
	fanpara2(g_par, g_fan, g_px, g_pa, g_d, g_rd);

	printf(" *** Write Image data   ***\n");
	// pr[ȅ
	write_data(g_f2, g_par, g_px*g_pa);

	// IɊmۂ̉
	free(g_fan);
	free(g_par);
}

// f[^̈̓́ifloatf[^j
void read_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(dat, sizeof(float), size, fp);
	fclose(fp);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void fanpara2(float *par, float *fan, int px, int pa, double d, int rd) 
// ̌õt@f[^̃t@pϊ
// float   *par; pr[̓ef[^
// float   *fan; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋Difj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
{
	int     i, j;
	double  xf, bf, sp, tp;
	// o`ԗpϐiX,j
	int     ix0, ix1, ib0, ib1;
	double  dx0, dx1, db0, db1;

	for(i = 0 ; i < pa ; i++)
	{
		tp = i*2*PI/pa*rd;   // pe̊px
		for(j = 0 ; j < px ; j++)
		{
			sp = j-px/2;                        // pëʒus
			xf = sp*d/sqrt(d*d-sp*sp);          // t@eiX=sD/D*D-s*sj
			bf = tp-atan2(sp, sqrt(d*d-sp*sp)); // t@ei=-arctan(s/D*D-s*s)j

			// X̐`ԏ
			xf = xf+px/2;
			ix0 = (int)floor(xf);
			ix1 = ix0+1;
			if(ix0 < 0 || ix1 > px-1) // ̈Ȍ
			{
				par[i*px+j] = (float)0;
				continue;
			}
			dx0 = xf-ix0;
			dx1 = 1-dx0;

			// ̐`ԏ
			bf = bf*pa/(2*PI);
			ib0 = (int)floor(bf);
			ib1 = ib0+1;
			db0 = bf-ib0;
			db1 = 1-db0;
			ib0 = (ib0+pa)%pa; // ěJԂl
			ib1 = (ib1+pa)%pa; // ěJԂl

			// o`
			par[i*px+j] = (float)
				(db0*dx0*fan[ib1*px+ix1]
				+db0*dx1*fan[ib1*px+ix0]
				+db1*dx0*fan[ib0*px+ix1]
				+db1*dx1*fan[ib0*px+ix0]);
		}
	}
}
