/*  P3-2ellipsefan.c  (Program 3-2)  */

/* --- vO̐ ---
@Shepp-Logant@g̑ȉ~f[^璼Ɍo킪zuꂽt@r[ef[^쐬vOD
 iȉ~ƒ̎璼ڋ߂j

́F
  1Do͂铊ef[^̃t@C
  2Def[^̓a̐io̐j
  3Def[^̊px̐iej
  4D]S܂ł̒ifj
  5Dẻ]i1: , -1: Ej

óF
  ȉ~f[^쐬ef[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char     g_f1[50] = "n3-2.prj"; /* output file name */
int      g_px = 256;            /* number of x-width */
int      g_pa = 256;            /* number of projection */
int      g_d  = 512;            /* source origin length */
int      g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
float    *g_prj;                /* projection data */

// ͗pRg
char *menu[] = {
	"P3-2 Make Fan-beam projection from ellipse data",
	"Output file name <float> ",
	"Number of bins               ",
	"Number of projection         ",
	"Source origin length (pixel) ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
	};

// vg^Cv錾
void write_data(char *, float *, int);
void ellipsefan(float *, int, int, int, int, double, double, double, double, double, double);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
}

void main(void)
{
	int  i;

	// vOŎgpϐ̓
	getparameter();

	// f[^̈̃𓮓IɊm
	g_prj = (float *)malloc((size_t)g_px*g_pa*sizeof(float));

	printf(" *** Making Projections ***\n");
	// f[^̏
	for(i = 0 ; i < g_px*g_pa ; i++)
		g_prj[i] = (float)0;

	// 3-D Sheppt@g̍쐬iȉ~17j
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.0,    0.69,   0.92,   0.0,  3.0 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.0184, 0.6624, 0.874,  0.0, -1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.22,  0.0,    0.11,   0.31, -18.0, -1.05);
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd, -0.22,  0.0,    0.16,   0.41,  18.0, -1.05);
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.35,   0.21,   0.25,   0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,   0.1,    0.046,  0.046,  0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.1,    0.046,  0.046,  0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd, -0.08, -0.605,  0.046,  0.023,  0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.0,  -0.605,  0.023,  0.023,  0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.06, -0.605,  0.023,  0.046,  0.0,  1.5 );
  ellipsefan(g_prj, g_px, g_pa, g_d, g_rd,  0.56, -0.4,    0.03,   0.2,  -21.0,  1.5 );

	printf(" *** Write Image data   ***\n");
	// ef[^̏o
	write_data(g_f1, g_prj, g_px*g_pa);

	// IɊmۂ̉
	free(g_prj);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void ellipsefan(float *prj, int px, int pa, int d, int rd, double x0, double y0, double a, double b, double th, double den)
// Ɍo킪ׂꂽt@r[̓ef[^ȉ~f[^쐬
// ȉ~ƒ̎璼ڋ߂
// float   *prj; 쐬铊ef[^
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// int     d;    X]S܂ł̋ipixelj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
// double  x0;   ȉ~̒SxWï̗[}1.0ɋKiĂj
// double  y0;   ȉ~̒SyWij
// double  a;    ȉ~x̌aij
// double  b;    ȉ~y̌aij
// double  th;   ȉ~̌Xixj
// double  den;  ȉ~̔Zx
{
	int     i, j;
	double  x, a0, a1, b0, b1, A0, A1, B0, B1;
	double  be, si, co, aa, ad, bd, cd, sq;
	double  sit, cot;
	double  rate = 1.0;
	static int n = 1;

	x0 *= px/2*rate;
	y0 *= px/2*rate;
	a  *= px/2*rate;
	b  *= px/2*rate;
	th *= PI/180;
	sit = sin(th);
	cot = cos(th);
	for(i = 0 ; i < pa ; i++)
	{
		fprintf(stderr, "\r -- ellipse(%02d) [%3d/%3d]", n, i, pa);
		be = i*2*PI/pa*rd;
		si = sin(be);
		co = cos(be);
		for(j = 0 ; j < px ; j++)
		{
			x  = j-px/2;
			b0 = -d*si;
			b1 =  d*co;
			aa = sqrt(d*d+x*x);
			a0 = (x*co-b0)/aa;
			a1 = (x*si-b1)/aa;

			// W̕sړ
			b0 -= x0;
			b1 -= y0;

			// xNgƍW̉]
			A0 =  cot*a0+sit*a1;
			A1 = -sit*a0+cot*a1;
			B0 =  cot*b0+sit*b1;
			B1 = -sit*b0+cot*b1;

			ad = (A0*A0)/(a*a)+(A1*A1)/(b*b);
			bd = (A0*B0)/(a*a)+(A1*B1)/(b*b);
			cd = (B0*B0)/(a*a)+(B1*B1)/(b*b)-1;

			if((sq = bd*bd-ad*cd) > 0.0)
			{
				prj[i*px+j] += (float)(2*sqrt(sq)/ad*den);
			}
		}		
	}
	fprintf(stderr, "\r -- ellipse(%02d) [%3d/%3d]\n", n++, i, pa);
}
