/*  P4-3spiralinear.c  (Program 4-3)  */

/* --- vO̐ ---
@720x̃XpCXLeԂgĒS360x̓e쐬vO

́F
  1DXpCXLef[^̃t@C
  2DԂꂽef[^̃t@C
  3Def[^̓a̐io̐j
  4Def[^̊px̐iej

óF
  XpCXLef[^Ԃč쐬ef[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-1.prj"; /* input file name */
char    g_f2[50] = "n4-2.prj"; /* output file name */
int     g_px = 256;            /* number of matrix (x) */
int     g_pa = 512;            /* number of matrix (y) */
float   *g_img;                /* spiral-scan data */
float   *g_im2;                /* interpolation data */

// ͗pRg
char *menu[] = {
	"P4-3 Spiral projection linear interpolation",
	"Input  file name <float> ",
	"Output file name <float> ",
	"Number of bins           ",
	"Number of projections    ",
	};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void spiral_linear(float *, float *, int, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
}

void main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// f[^̈̃𓮓IɊm
	g_img = (float *)malloc((size_t)g_px*g_pa*sizeof(float));
	g_im2 = (float *)malloc((size_t)g_px*g_pa/2*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// ef[^̓
	read_data(g_f1, g_img, g_px*g_pa);

	printf(" *** Linear interpolation ***\n");
	// ef[^̐`
	spiral_linear(g_im2, g_img, g_px, g_pa);

	printf(" *** Write Image data   ***\n");
	// Ԃef[^̏o
	write_data(g_f2, g_im2, g_px*g_pa/2);

	// IɊmۂ̉
	free(g_img);
	free(g_im2);
}

// f[^̈̓́ifloatf[^j
void read_data(char *fi, float *prj, int size)
{
	FILE   *fp;

	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(prj, sizeof(float), size, fp);
	fclose(fp);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void spiral_linear(float *im2, float *img, int px, int pa) 
// XpCXL̓ef[^`Ԃ
// float   *im2;    `Ԍ̓ef[^ipx1/2ɂȂĂj
// float   *img;    ԑO̓ef[^
// int     px;      ef[^̌o̐
// int     pa;      ef[^̓eiԑO̐j
{
	int     i, j;
	double  t;

	for(i = 0 ; i < pa/2 ; i++)
	{
		t = i/(double)(pa/2);
		for(j = 0 ; j < px ; j++)
		{
			// `
			im2[i*px+j] = (float)(t*img[i*px+j]+(1-t)*img[(i+pa/2)*px+j]);
		}
	}
}
