// P7-1Radon_corn_1.cpp ivO 7-1)
// @ 1 ɂR[r[ẽvO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define PI 3.14159265358979

void read_data(char [], float *, int);
void rotate(float *, int, int, double);
void rotate_3d(float *, int, int, int, double, int);
void write_data(char [], float *, int);

int main(void)
{
	char f1[50],f2[50];
	int nx,ny,nz,n,i,k,j;
	double th, fai;
	double *beam_x, *beam_y, *beam_z, xl, yl, x_p, z_p;
	int x, y, z, x_1, z_1;
	float *img, *radon_3d, *flat, *img_cp;
	double source_x, source_y, source_z, sd, lp, lx, lz, xx, zz, x_v, z_v;


	nx=ny=nz=128;
	img=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	img_cp=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	radon_3d=(float *)malloc((unsigned long)256*256*256*sizeof(float));
	flat=(float *)malloc((unsigned long)256*256*sizeof(float));
	beam_x=(double *)malloc((unsigned long)ny*8*sizeof(double));
	beam_y=(double *)malloc((unsigned long)ny*8*sizeof(double));
	beam_z=(double *)malloc((unsigned long)ny*8*sizeof(double));

	/* o͉摜̓ǂݍ */
	printf("input file name <float>:");
	scanf("%s", f1);
	printf("output file name <float>:");
	scanf("%s", f2);

	read_data(f1, img, nx*ny*nz);

	/* o͉摜̏ */
	for(i=0; i<nx*ny*nz*8; i++) radon_3d[i]=0;

	/* ̍W */
	source_x=source_z=0.00;
	source_y=-2.00*nx;

	/* ]]Sԋ */
	sd=2.00*nx;

	for(n=0; n<ny*2; n++){
		/* 摜͉]s߃Rs[Ƃ */
		for(i=0; i<nx*ny*nz; i++) img_cp[i]=img[i];

		/* Rs[摜ɉ] */
		rotate_3d(img_cp, nx, ny, nz, 360.00*n/(2.00*ny), 3);
		
		/* ȍ */
		for(i=0; i<nx*ny*4; i++) flat[i]=0;
		for(i=0; i<ny*8; i++) beam_x[i]=beam_y[i]=beam_z[i]=0;

		for(k=0; k<ny*2; k++){
			/* ȍcW */
			yl=nz-k;
			for(j=0; j<nx*2; j++){
				/* ỏW */
				xl=j-nx;
			
				/*o̍Wt@pCR[p𓱏o*/
				/* t@p */
				th=atan2(xl, 2.00*sd);

				/* R[p */
				fai=atan2(yl, 2.00*sd);

				/*cɂPfiލۂɉCɐiޒ𓱏o*/
				x_p=tan(th);
				z_p=sqrt(x_p*x_p+1)*tan(fai);

				/*Pfʉ߂ۂɕːiޒ*/
				lp=sqrt(x_p*x_p+z_p*z_p+1.000);

				/*W̒l xp, zp gpĕːʉ߂W𓱏o*/
				for(i=0; i<2*sd; i++){
					beam_y[i]=source_y+i;
					beam_x[i]=i*x_p;
					beam_z[i]=i*z_p;
			
					x=floor(beam_x[i]);
					y=floor(beam_y[i]);
					z=floor(beam_z[i]);

					/*摜ʉ߂Ȃː͖*/
					if((-nz/2+2)<z && z<(nz/2-1) && (-nx/2+1)<x && x<(nx/2-1) && (-ny/2+2)<y && y<(ny/2-1) ){
						
						/* z,x ̒Pʈړɒʉ߂f߂ */
						x_v=floor(beam_x[i])-floor(beam_x[i-1]);
						z_v=floor(beam_z[i])-floor(beam_z[i-1]);
	
						/* 1̉f̏ꍇ */
						if(fabs(x_v)<0.001 && fabs(z_v)<0.001){
							lx=lz=0;
							flat[k*nx*2+j]+=lp*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x+nx/2)];
						}
						/* x2fʉ߂ꍇ */
						else if(fabs(x_v)>0.001 && fabs(z_v)<0.001){
							
							/* EƂȂW̓o */
							if(x_p*beam_x[i]>=0) xx=(int)(beam_x[i]);
							else xx=(int)(beam_x[i-1]);
							/* PʈړO̍W狫E܂ł̋ */
							lx=lp*(xx-beam_x[i-1])/x_p;

							/* i-1 Ԗڂ̍W */
							x_1=floor(beam_x[i-1]);

							/* Ɖfl̐ς̑a */
							flat[k*nx*2+j]+=(lp-lx)*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x+nx/2)]
											+lx*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x_1+nx/2)];
						}
						/* z2fʉ߂ꍇ */
						else if(fabs(x_v)<0.001 && fabs(z_v)>0.001){

							/* EƂȂW̓o */
							if(z_p*beam_z[i]>=0) zz=(int)(beam_z[i]);
							else zz=(int)(beam_z[i-1]);
							/* PʈړO̍W狫E܂ł̋ */
							lz=lp*(zz-beam_z[i-1])/z_p;
							
							/* i-1 Ԗڂ̍W */
							z_1=floor(beam_z[i-1]);
							
							/* Ɖfl̐ς̑a */
							flat[k*nx*2+j]+=(lp-lz)*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x+nx/2)]
											+lz*img_cp[(nz/2-z_1)*nx*ny+(ny/2-y)*nx+(x+nx/2)];
						}
						else if(fabs(x_v)<0.001 && fabs(z_v)>0.001){

							/* EƂȂW̓o */
							if(x_p*beam_x[i]>=0) xx=(int)(beam_x[i]);
							else xx=(int)(beam_x[i-1]);
							if(z_p*beam_z[i]>=0) zz=(int)(beam_z[i]);
							else zz=(int)(beam_z[i-1]);

							/* PʈړO̍W狫E܂ł̋ */
							lx=lp*(xx-beam_x[i-1])/x_p;
							lz=lp*(zz-beam_z[i-1])/z_p;

							/* i-1 Ԗڂ̍W */
							x_1=floor(beam_x[i-1]);
							z_1=floor(beam_z[i-1]);
							
							/* z,x ̋Eʉ߂鏇Ԃɂ苗𓱏o */
							/* z ɐɋE𒴂ꍇ */
							if(lx>lz){
								flat[k*nx*2+j]+=lz*img_cp[(nz/2-z_1)*nx*ny+(ny/2-y)*nx+(x_1+nx/2)]
												+(lx-lz)*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x_1+nx/2)]
												+(lp-lx)*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x+nx/2)];
							}
							/* x ɐɋE𒴂ꍇ */
							else if(lz>lx){
								flat[k*nx*2+j]+=lx*img_cp[(nz/2-z_1)*nx*ny+(ny/2-y)*nx+(x_1+nx/2)]
												+(lz-lx)*img_cp[(nz/2-z_1)*nx*ny+(ny/2-y)*nx+(x+nx/2)]
												+(lp-lz)*img_cp[(nz/2-z)*nx*ny+(ny/2-y)*nx+(x+nx/2)];
							}
						}
					}
				}
			}
		}
		/* 2o̒l */
		for(i=0; i<nx*ny*4; i++) radon_3d[n*nx*ny*4+i]=flat[i];
		printf("%d\r", n);
	}

	/* 쐬hϊ̏o */
	write_data(f2, radon_3d, nx*ny*nz*8);
	
	free(img);
	free(img_cp);
	free(radon_3d);
	free(flat);
	free(beam_x);
	free(beam_y);
	free(beam_z);

}

void read_data(char fi[], float *img, int size)
{	
	FILE *fp;
	if((fp=fopen(fi,"rb"))==NULL){
		printf("error input data");
		exit(1);
	}
	fread(img,sizeof(float),size,fp);
	fclose(fp);
}

void rotate(float *img, int nx, int ny, double th)
{
	int i,j,i0,j0,i1,j1;
	double x0,y0,si,co;
	float *ima;

	ima=(float *)malloc((unsigned long)nx*ny*sizeof(float));

	co=cos(th*PI/180); si=sin(th*PI/180);

	for(i=0; i<nx*ny; i++){
		ima[i]=0;
	}

	for(i=0; i<ny; i++){
		for(j=0; j<nx; j++){
			x0=(j-nx/2)*co-(ny/2-i)*si+nx/2;
			j0=(int)x0;
			j1=j0+1;
			y0=-(j-nx/2)*si-(ny/2-i)*co+ny/2;
			i0=(int)y0;
			i1=i0+1;

			if(i0>=0 && i1<ny && j0>=0 && j1<nx){
				ima[i*nx+j]=(float)((j1-x0)*(i1-y0)*img[i0*nx+j0]
				            +(x0-j0)*(i1-y0)*img[i0*nx+j1]
							+(j1-x0)*(y0-i0)*img[i1*nx+j0]
							+(x0-j0)*(y0-i0)*img[i1*nx+j1]);
			}
			else{ 
				ima[i*nx+j]=0;
			}
		}
	}

	for(i=0; i<nx*ny; i++){
		img[i]=ima[i];
	}

	free(ima);
}

void rotate_3d(float *img, int nx, int ny, int nz, double th, int axis)
{
	int k,i,j;
	float *img2;

	img2=(float *)malloc((unsigned long)nx*ny*sizeof(float));

	if(axis==1){
		//printf("ɉ]܂\n");
		for(j=0; j<nx; j++){
			for(k=0; k<nz; k++){
				for(i=0; i<ny; i++){
					img2[k*nx+i]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th);
			for(k=0; k<nz; k++){
				for(i=0; i<ny; i++){
					img[k*nx*ny+i*nx+j]=img2[k*nx+i];
				}
			}
		}
	}
	else if(axis==2){
		//printf("ɉ]܂\n");
		for(i=0; i<ny; i++){
			for(k=0; k<nz; k++){
				for(j=0; j<nx; j++){
					img2[k*nx+j]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th);
			for(k=0; k<nz; k++){
				for(j=0; j<nx; j++){
					img[k*nx*ny+i*nx+j]=img2[k*nx+j];
				}
			}
		}
	}
	else if(axis==3){
		//printf("ɉ]܂\n");
		for(k=0; k<nz; k++){
			for(i=0; i<ny; i++){
				for(j=0; j<nx; j++){
					img2[i*nx+j]=img[k*nx*ny+i*nx+j];
				}
			}
			rotate(img2, nx, ny, th);
			for(i=0; i<ny; i++){
				for(j=0; j<nx; j++){
					img[k*nx*ny+i*nx+j]=img2[i*nx+j];
				}
			}
		}
	}
	else printf("̑IɎs܂\n");

	free(img2);

}

void write_data(char fi[],float *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(float),size,fp);
	fclose(fp);
}