// P7-4Radon_corn_4.cppivO 7-4)
// @ 4 ɂR[r[ẽvO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define PI 3.14159265358979

void read_data(char [], float *, int);
void write_data(char [], float *, int);
void write_data_short(char [], short *, int);

double point_projection(float *img, float *img_line, float *long_sum, double source_xyz[], double detector_xyz[], int zd, int yd, int xd, int nx, int ny, int nz, double sd)
{
	double detector;
	int j, m;
	int in_out;
	double x_p, y_p, z_p;
	int xyz;
	double sub_x, sub_y, sub_z, sub[3], min, bx, by, bz, floor_x, floor_y, floor_z;

	/*-------------- 蓊e̍ --------------*/

	/* PʂɐiލW */
	x_p=(double)(detector_xyz[0]-source_xyz[0])/(2.0000*sd);
	y_p=(double)(detector_xyz[1]-source_xyz[1])/(2.0000*sd);
	z_p=(double)(detector_xyz[2]-source_xyz[2])/(2.0000*sd);

	/* X摜ʉ߂Ă邩̔ɗp */
	in_out=0;

	/* Ɖfl̐ς̑ai߂lj */
	detector=0;
	
	/* X̐i */
	for(j=0; j<2*sd; j++){

		/* 摜ʉ߂Ȃꍇ͒PʃxNgƂɈړ */
		if(in_out==0){
			by=source_xyz[1]+y_p*(double)j;
			bx=source_xyz[0]+(double)j*x_p;
			bz=source_xyz[2]+(double)j*z_p;

			xyz=-1;
		}
			
		if((-nx/2+1)<bx && bx<(nx/2-2) && (-ny/2+2)<by && by<(ny/2-1) && (-nz/2+2)<bz && bz<(nz/2-1) ){
			
			/*ː̍W̏_ȉ؂̂*/
			floor_x=floor(bx);
			floor_y=floor(by);
			floor_z=floor(bz);
				
			/*␳FO̍W̍XV x,y,z ̂ꂼǂ̒l
			@@@@@@ɂɂCɂȂl͐ł邽ߕ␳*/

			if(fabs(bx-floor_x)<0.000001 || fabs(bx-floor_x)>0.999999){
				if(x_p>=0) floor_x+=1.00;
				else floor_x+=-1.00;
			}
			if(fabs(by-floor_y)<0.000001 || fabs(by-floor_y)>0.999999){
				if(y_p>=0) floor_y+=1.00;
				else floor_y+=-1.00;
			}
			if(fabs(bz-floor_z)<0.000001 || fabs(bz-floor_z)>0.999999){
				if(z_p>=0) floor_z+=1.00;
				else floor_z+=-1.00;
			}

			/*̉fʉ߂܂ł x,y,z łǂقǋ邩߂*/
			if(x_p>=0) sub_x=floor_x+1.0000000-bx;
			else if(x_p<0) sub_x=floor_x-bx;

			if(y_p>=0) sub_y=floor_y+1.0000000-by;
			else if(y_p<0) sub_y=floor_y-by;

			if(z_p>=0) sub_z=floor_z+1.0000000-bz;
			else if(z_p<0) sub_z=floor_z-bz;

			/* x,y,z ̋PʃxNgPʂōl*/
			sub[0]=sub_x/x_p;
			sub[1]=sub_y/y_p;
			sub[2]=sub_z/z_p;

			if(xyz==0) sub[0]=fabs(1.00000/x_p);
			else if(xyz==1) sub[1]=fabs(1.00000/y_p);
			else if(xyz==2) sub[2]=fabs(1.00000/z_p);
			
			/*̍ŏl𓱏o*/
			min=sub[0];
			xyz=0;
			for(m=1; m<3; m++){
			if(min>sub[m]){
					min=sub[m];
					xyz=m;
				}
			}

			/*˓_ʉߓ_̋Ɖfl̐ς𓱏o*/
			detector+=min*(double)img[(nz/2-(int)((floor)(bz)))*nx*ny+(ny/2-(int)((floor)(by)))*nx+(int)((floor)(bx))+nx/2];
			img_line[(nz/2-(int)((floor)(bz)))*nx*ny+(ny/2-(int)((floor)(by)))*nx+(int)((floor)(bx))+nx/2]+=min;
			long_sum[zd*nx*ny*4+yd*nx*2+xd]+=min;

			/*̉fɐiނ߁Cʉߓ_˓_ɍXV*/
			bx+=sub[xyz]*x_p;
			by+=sub[xyz]*y_p;
			bz+=sub[xyz]*z_p;

			/*t@g摜ːiނ߁Cin_out=10 Ƃ*/
			in_out=10;
		}
	}

	return detector;
}

int main(void)
{
	char f1[50],f2[50];
	int nx,ny,nz,i,k,j;
	float  *detector;
	double ganma;
	float *img_line;
	float *img, *img_beam;
	float *long_sum;
	double source_xyz[3], detector_xyz[3];
	double sd,th,th_p;

	clock_t t1,t2;
	t1=clock();

	nx=ny=nz=128;
	img=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	img_beam=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	img_line=(float *)malloc((unsigned long)nx*ny*nz*sizeof(float));
	detector=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));
	long_sum=(float *)malloc((unsigned long)nx*ny*nz*8*sizeof(float));

	/* o͉摜̓ǂݍ */
	printf("input file name <float>:");
	scanf("%s", f1);
	printf("output file name <float>:");
	scanf("%s", f2);

	/*摜̓ǂݍ*/
	read_data(f1, img, nx*ny*nz);

	for(i=0; i<nx*ny*nz*8; i++) detector[i]=long_sum[i]=0;
	for(i=0; i<nx*ny*nz; i++) img_beam[i]=img_line[i]=0;

	sd=2.000*(double)nx;

	/* 
	^ǒȍꍇC̉f
	̊ŕωpx̐ݒ
	*/
	//th_p=360.00/(2.00*sd*PI);

	for(k=0; k<ny*2; k++){
		ganma=(double)k*(360.00/(nz*2.00))*PI/180.00;
		/*̍W*/
		source_xyz[0]=(double)nx*2.000*sin(ganma);
		source_xyz[1]=-(double)nx*2.000*cos(ganma);
		source_xyz[2]=0.00;
		
		for(i=0; i<ny*2; i++){
			/* ozW */
			detector_xyz[2]=(double)(ny-i);

			for(j=0; j<nx*2; j++){

				/* ^o */
				//th=atan2((double)(j-nx), 2.000*(double)sd);
				/*o̍W*/
				//detector_xyz[0]=-sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*sin(ganma+2.00*th+(j-nx)*th_p);
				//detector_xyz[1]=sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*cos(ganma+2.00*th+(j-nx)*th_p);

				/* ʌo */
				/* t@p */
				th=atan2((double)(j-nx), 2.000*(double)sd);

				/* o̍W */
				detector_xyz[0]=-sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*sin(ganma+2.00*th);
				detector_xyz[1]=sqrt(2.000*(double)nx*2.000*(double)nx+(double)(j-nx)*(double)(j-nx))*cos(ganma+2.00*th);

				/*
				vZɂ蓾W{ł 0 lɁC-0.000000 Ȃǂ
				l邱Ƃɂ蓊eȂꍇD
				̃G[h߂Ɉȉ̐Βl 0.000001 ȉ̏ꍇ͐l 0 ƂD
				*/
				if(fabs(source_xyz[0])<0.000001) source_xyz[0]=0.0000000;
				if(fabs(source_xyz[1])<0.000001) source_xyz[1]=0.0000000;
				if(fabs(source_xyz[2])<0.000001) source_xyz[2]=0.0000000;
				if(fabs(detector_xyz[0])<0.000001) detector_xyz[0]=0.0000000;
				if(fabs(detector_xyz[1])<0.000001) detector_xyz[1]=0.0000000;
				if(fabs(detector_xyz[2])<0.000001) detector_xyz[2]=0.0000000;

				/* Xʉ߂flƋ̐ς̑a߂ */
				detector[k*nx*ny*4+(i)*nx*2+j]=(float)point_projection(img, img_line, long_sum, source_xyz, detector_xyz, k, i, j, nx, ny, nz, sd);

			}
		}
		printf("%d\r", /*(int)((double)(k)/((double)nz*2.00*4.00)*100.0)*/k);
	}

	/* 쐬hϊ̏o */
	write_data(f2, detector, nx*ny*nz*8);

	/* o̊efƂXʉ߂ l_sum1 ̏o */
	write_data("long_sum_detector.img", long_sum, nx*ny*nz*8);

	/* 摜̊efƂXʉ߂ l_sum2 ̏o */
	write_data("long_sum_voxel.img", img_line, nx*ny*nz);

	t2=clock();
	printf("vԁF%f\n",(double)(t2-t1)/CLOCKS_PER_SEC);


	free(img);
	free(img_line);
	free(detector);
	free(long_sum);
	free(img_beam);
}
void read_data(char fi[], float *img, int size)
{	
	FILE *fp;
	if((fp=fopen(fi,"rb"))==NULL){
		printf("error input data");
		exit(1);
	}
	fread(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data(char fi[], float *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(float),size,fp);
	fclose(fp);
}

void write_data_short(char fi[], short *img, int size)
{
	FILE *fp;
	if((fp=fopen(fi,"wb"))==NULL){
		printf("error output data");
		exit(1);
	}
	fwrite(img,sizeof(short),size,fp);
	fclose(fp);
}
